/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.jsf.runtime;

import org.seasar.extension.unit.S2TestCase;
import org.seasar.jsf.runtime.TagPoolEntry;
import org.seasar.jsf.taglib.ElementTag;

/**
 * @author higa
 *
 */
public class TagPoolEntryTest extends S2TestCase {

	public TagPoolEntryTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(TagPoolEntryTest.class);
	}
	
	public void testRequestAndRelease() throws Exception {
		TagPoolEntry entry = new TagPoolEntry(ElementTag.class);
		ElementTag tag = (ElementTag) entry.request();
		assertNotNull("1", tag);
		entry.release(tag);
		assertEquals("2", tag, entry.request());
	}
}